示例#1
0
        /// <summary>
        /// Implement this method as an external command for Revit.
        /// </summary>
        /// <param name="commandData">An object that is passed to the external application
        /// which contains data related to the command,
        /// such as the application object and active view.</param>
        /// <param name="message">A message that can be set by the external application
        /// which will be displayed if a failure or cancellation is returned by
        /// the external command.</param>
        /// <param name="elements">A set of elements to which the external application
        /// can add elements that are to be highlighted in case of failure or cancellation.</param>
        /// <returns>Return the status of the external command.
        /// A result of Succeeded means that the API external method functioned as expected.
        /// Cancelled can be used to signify that the user cancelled the external operation
        /// at some point. Failure should be returned if the application is unable to proceed with
        /// the operation.</returns>
        public Autodesk.Revit.UI.Result Execute(Autodesk.Revit.UI.ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements)
        {
            Autodesk.Revit.UI.UIApplication application = commandData.Application;
            m_docment = application.ActiveUIDocument.Document;
            try
            {
                // user should select one slab firstly.
                if (application.ActiveUIDocument.Selection.Elements.Size == 0)
                {
                    TaskDialog.Show("Revit", "Please select one slab firstly.", TaskDialogCommonButtons.Ok);
                    return(Autodesk.Revit.UI.Result.Cancelled);
                }

                // get the selected slab and show its span direction
                ElementSet         elementSet = application.ActiveUIDocument.Selection.Elements;
                ElementSetIterator elemIter   = elementSet.ForwardIterator();
                elemIter.Reset();
                while (elemIter.MoveNext())
                {
                    Floor floor = elemIter.Current as Floor;
                    if (floor != null)
                    {
                        GetSpanDirectionAndSymobls(floor);
                    }
                }
            }
            catch (Exception ex)
            {
                message = ex.ToString();
                return(Autodesk.Revit.UI.Result.Failed);
            }
            return(Autodesk.Revit.UI.Result.Succeeded);
        }
示例#2
0
        /// <summary>
        /// Reads the current selection of Revit.
        /// </summary>
        /// <param name="errorMessage">The error message.</param>
        /// <returns>True if reading succeed; otherwise, false.</returns>
        private bool ReadSelectedElementFromRevit(out string errorMessage)
        {
            errorMessage = string.Empty;

            if (ThisExtension.Revit.ActiveUIDocument.Selection.Elements.Size == 0)
            {
                errorMessage = "The selection is empty";
                return(false);
            }

            if (ThisExtension.Revit.ActiveUIDocument.Selection.Elements.Size > 1)
            {
                errorMessage = "The selection contains more than one element";
                return(false);
            }

            ElementSetIterator iterator = ThisExtension.Revit.ActiveUIDocument.Selection.Elements.ForwardIterator();

            iterator.Reset();
            iterator.MoveNext();
            FamilyInstance familyInstance = iterator.Current as FamilyInstance;

            if (familyInstance == null)
            {
                errorMessage = "Selected element is not a FamilyInstance";
                return(false);
            }

            if (familyInstance.StructuralType == Autodesk.Revit.DB.Structure.StructuralType.Beam ||
                familyInstance.StructuralType == Autodesk.Revit.DB.Structure.StructuralType.Column ||
                familyInstance.StructuralType == Autodesk.Revit.DB.Structure.StructuralType.Brace)
            {
                ThisMainExtension.Data.SelectedElement = familyInstance;
                FillPropertiesOfSelectedElement();
                FillGeometryOfSelectedElement();
                return(true);
            }
            else
            {
                errorMessage = "Selected element is not a beam nor a column";
                return(false);
            }
        }